package cpcns.ldanganzhengli.ldanganhe.controller;

package .tmp;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.common.controller.commonController;
import cpcns.ldanganzhengli.ldanganhe.model.LDangAnHe;
import cpcns.ldanganzhengli.ldanganhe.service.ILDangAnHeService;
import cpcns.utils.CommStatic;
import cpcns.utils.DateUtil;
import cpcns.utils.Json;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/LDangAnHe"})
public class LDangAnHeController extends commonController {
  @Autowired
  private ILDangAnHeService LDangAnHeService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request) throws Exception {
    String yiJiaoPiCi = request.getParameter("yiJiaoPiCi");
    String menLei = request.getParameter("menLei");
    getRequest().setAttribute("yiJiaoPiCi", yiJiaoPiCi);
    getRequest().setAttribute("menLei", menLei);
    return "ldanganzhengli/ldanganhe/LDangAnHeList";
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (hangBiaoShi != null && !hangBiaoShi.equals("")) {
      LDangAnHe cla = (LDangAnHe)this.LDangAnHeService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      String sb = " select min(xuHao) from " + CommStatic.getMenLeiToBiaoMing(cla.getMenLei()) + " where guanLianBiaoShi= " + cla.getHangBiaoShi();
      List<String> list = this.LDangAnHeService.selectSql(sb);
      if (list != null && list.size() > 0 && list.get(0) != null && list.get(0) != "")
        cla.setQiYeHao(Integer.valueOf(list.get(0).toString())); 
      sb = " select max(xuHao) from " + CommStatic.getMenLeiToBiaoMing(cla.getMenLei()) + " where guanLianBiaoShi= " + cla.getHangBiaoShi();
      list = this.LDangAnHeService.selectSql(sb);
      if (list != null && list.size() > 0 && list.get(0) != null && list.get(0) != "")
        cla.setZhiYeHao(Integer.valueOf(list.get(0).toString())); 
      cla.setChrq(DateUtil.getDate(cla.getChengHeShiJian()));
      getRequest().setAttribute("dangAnHe", cla);
    } 
    return "ldanganzhengli/ldanganhe/LDangAnHeEdit";
  }
  
  @RequestMapping({"/toHeNeiJian.do"})
  public String toHeNeiJian() {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    String menLei = getRequest().getParameter("menLei");
    getRequest().setAttribute("menLei", menLei);
    getRequest().setAttribute("heBiaoShi", hangBiaoShi);
    return "ldanganzhengli/ldanganhe/LHeNeiJian";
  }
  
  @RequestMapping({"/getAll.do"})
  public void getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    User user = getCurrentUser();
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    StringBuffer sqlSearch = new StringBuffer();
    sqlSearch.append(" 1=1 ");
    String hbs_n1 = isJianDing();
    String hbs_n2 = isOrNotJieYue();
    if (StringUtils.isNotBlank(hbs_n1))
      sqlSearch.append(" and hangBiaoShi not in (" + hbs_n1 + ")"); 
    if (StringUtils.isNotBlank(hbs_n2))
      sqlSearch.append(" and hangBiaoShi not in (" + hbs_n2 + ")"); 
    sqlSearch.append(" and baoGuanQiXian !='D10'");
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key)) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          sqlWhere.append(" and ").append(
              String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key)) {
          if (key.contains("like")) {
            key = key.substring(0, key.indexOf("like"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value + "%'");
            continue;
          } 
          sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
        } 
      } 
    } 
    if (sqlWhere.length() > 0)
      sqlSearch.append(sqlWhere.toString()); 
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    StringBuffer sql = new StringBuffer("select hangBiaoShi,xuHao,quanZongHao,fenShu,heRongLiang,zhuangTai,zeRenRenMingCheng,guiDangDanWeiMingCheng,baoGuanQiXian,guiDangNianDu,menLei,fenLeiMingCheng,miJi,ruKuFangZhuangTai,yiJiaoPiCi from L_DangAnHe where ");
    PagerVO pagevo = this.LDangAnHeService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "xuHao asc"));
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao")
      .replaceAll("FENSHU", "fenShu").replaceAll("HERONGLIANG", "heRongLiang").replaceAll("QUANZONGHAO", "quanZongHao")
      .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("ZERENRENMINGCHENG", "zeRenRenMingCheng").replaceAll("LIJUANDANWEIMINGCHENG", "liJuanDanWeiMingCheng")
      .replaceAll("GUIDANGDANWEIMINGCHENG", "guiDangDanWeiMingCheng").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian")
      .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MENLEI", "menLei").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng")
      .replaceAll("MIJI", "miJi").replaceAll("RUKUFANGzhuangTai", "ruKuFangZhuangTai").replaceAll("YIJIAOPICI", "yiJiaoPiCi");
    write(response, jsonString);
  }
  
  private String isJianDing() {
    StringBuffer sql_qx = new StringBuffer("select qx.jianDingBiaoShi from D_BaoGuanQiXianJianDing qx,D_JianDingFangAn fa where qx.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer sql_gk = new StringBuffer("select gk.jianDingBiaoShi from D_WenJianMiJiJianDing gk,D_JianDingFangAn fa where gk.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer retu = new StringBuffer();
    List<String> qx = this.LDangAnHeService.getList(sql_qx.toString());
    if (qx != null && qx.size() > 0)
      for (int i = 0; i < qx.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(qx.get(i));
        } else {
          retu.append("," + qx.get(i));
        } 
      }  
    List<String> gk = this.LDangAnHeService.getList(sql_gk.toString());
    if (gk != null && gk.size() > 0)
      for (int i = 0; i < gk.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(gk.get(i));
        } else {
          retu.append("," + gk.get(i));
        } 
      }  
    String ret = getJH(retu.toString());
    return ret;
  }
  
  private String isOrNotJieYue() {
    StringBuffer hangBiaoShi = new StringBuffer();
    String da = (new SimpleDateFormat("yyyy-MM-dd")).format(new Date());
    StringBuffer sql = new StringBuffer("select wj.guanLianBiaoShi from D_LiYongWenJian wj,D_LiYongShenQingDan sqd where wj.shenQingDanBiaoShi=sqd.hangBiaoShi and ((sqd.liYongFangShi=10 and sqd.yingHuanRiQi>=to_date('" + da + "','yyyy-mm-dd')) or (sqd.liYongFangShi=20 and wj.zhuangTai=1))");
    List<String> lis = this.LDangAnHeService.getList(sql.toString());
    if (lis != null && lis.size() > 0)
      for (int i = 0; i < lis.size(); i++) {
        if (StringUtils.isBlank(hangBiaoShi.toString())) {
          hangBiaoShi.append(lis.get(i));
        } else {
          hangBiaoShi.append("," + lis.get(i));
        } 
      }  
    String ret = getJH(hangBiaoShi.toString());
    return ret;
  }
  
  private String getJH(String hangBiaoShi) {
    StringBuffer ret = new StringBuffer();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      StringBuffer sql_h = new StringBuffer("select distinct guanLianBiaoShi from D_WenJian where hangBiaoShi in (" + hangBiaoShi + ")");
      List<String> jh = this.LDangAnHeService.getList(sql_h.toString());
      if (jh != null && jh.size() > 0)
        for (int i = 0; i < jh.size(); i++) {
          if (StringUtils.isBlank(ret.toString())) {
            ret.append(jh.get(i));
          } else {
            ret.append("," + jh.get(i));
          } 
        }  
    } 
    return ret.toString();
  }
  
  @RequestMapping({"/openDat.do"})
  @ResponseBody
  public String returnJos(HttpServletRequest request, HttpServletResponse response, Model model) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    Map<String, Object> resultMap = new HashMap<>();
    resultMap.put("filePath", "");
    String jsonString = "";
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      LDangAnHe cla = (LDangAnHe)this.LDangAnHeService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      resultMap.put("filePath", cla);
    } 
    jsonString = Json.Map2Json(resultMap);
    return jsonString;
  }
}
